Index: code/branches/ScriptableController/data/levels/levelTry.oxw
===================================================================
--- code/branches/ScriptableController/data/levels/levelTry.oxw	(revision 10023)
+++ code/branches/ScriptableController/data/levels/levelTry.oxw	(revision 10024)
@@ -112,5 +112,5 @@
 
 <!-- Object, which orxouts the message "hello Universe!". EVENT NOT WORKING  -->
-    <ScriptController_00 position="0,0,0">
+    <ControllerDirector position="0,0,0">
         <events>
             <party>
@@ -120,5 +120,5 @@
         </events>
 
-    </ScriptController_00>
+    </ControllerDirector>
 
 
Index: code/branches/ScriptableController/src/orxonox/controllers/ControllerDirector.cc
===================================================================
--- code/branches/ScriptableController/src/orxonox/controllers/ControllerDirector.cc	(revision 10023)
+++ code/branches/ScriptableController/src/orxonox/controllers/ControllerDirector.cc	(revision 10024)
@@ -1,25 +1,31 @@
 /*
-First try of a scriptController. Target: An event occurs in the levelTry.oxw file, which is "heard" by an object of the type of this class. It then SHOULD (because it is not working) execute the party function.
+First try of a ControllerDirector. Target: An event occurs in the levelTry.oxw file, which is "heard" by an object of the type of this class. It then SHOULD (because it is not working) execute the party function.
  */
 
-#include "ScriptController.h"
+#include "ControllerDirector.h"
 #include "core/CoreIncludes.h"
+
+//#include "network/NetworkFunction.h"
+
+#include "infos/HumanPlayer.h"
+#include "interfaces/PlayerTrigger.h"
+#include "worldentities/pawns/Pawn.h"
 
 namespace orxonox
 {
-    RegisterClass(ScriptController);
+    RegisterClass(ControllerDirector);
 
-    ScriptController::ScriptController(Context* context) : ArtificialController(context)
+    ControllerDirector::ControllerDirector(Context* context) : ArtificialController(context)
     {
 	//Working
-        RegisterObject(ScriptController);
+        RegisterObject(ControllerDirector);
         orxout()<<"hello universe constructor"<< endl;
 
-	this->player_=NULL;
-	this->entity_=NULL;
-	this->pTrigger_=NULL;
+	   this->player_=NULL;
+	   this->entity_=NULL;
+	   this->pTrigger_=NULL;
     }
 
-    bool ScriptController::party(bool bTriggered, BaseObject* trigger)
+    bool ControllerDirector::party(bool bTriggered, BaseObject* trigger)
        {
 	   //XMLPortEventSink seems not to execute the party function
@@ -29,15 +35,23 @@
 
 
-    void ScriptController::XMLPort(Element& xmlelement, XMLPort::Mode mode)
+    void ControllerDirector::XMLPort(Element& xmlelement, XMLPort::Mode mode)
     {
-        SUPER(ScriptController, XMLPort, xmlelement, mode);
+        SUPER(ControllerDirector, XMLPort, xmlelement, mode);
 
 	
-    	XMLPortEventSink(ScriptController, BaseObject, "party", party, xmlelement, mode);
-	// Working
         orxout()<<"hello universe xmlport"<< endl;
     }
 
-    void ScriptController::tick(float dt)
+    void ControllerDirector::XMLEventPort(Element& xmlelement, XMLPort::Mode mode)
+    {
+        SUPER(ControllerDirector, XMLEventPort, xmlelement, mode);
+
+        XMLPortEventSink(ControllerDirector, BaseObject, "party", party, xmlelement, mode);
+
+    }
+
+
+
+   /* void ControllerDirector::tick(float dt)
     {
 
@@ -50,32 +64,32 @@
         
 
-        SUPER(ScriptController, tick, dt);
+        SUPER(ControllerDirector, tick, dt);
     }
 
-    void ScriptController::takeControl(Controller * controller, BaseObject * trigger) {
+    */
 
-	preparationToTakeControl(trigger);
-	setNewController(controller);
+    void ControllerDirector::takeControl(Controller * controller, BaseObject * trigger) {
 
-    }
+        preparationToTakeControl(trigger);
+        setNewController(controller);
+
+    } 
 
 	
-    bool ScriptController::preparationToTakeControl(BaseObject * trigger) {
+    bool ControllerDirector::preparationToTakeControl(BaseObject * trigger) {
 
-	this->pTrigger_ = orxonox_cast<PlayerTrigger*>(trigger);
+	    this->pTrigger_ = orxonox_cast<PlayerTrigger*>(trigger);
         this->player_ = NULL;
 
+        orxout() << "Preparation to take Control!" << endl; 
         // Check whether it is a player trigger and extract pawn from it
-        if(pTrigger != NULL)
+        if(this->pTrigger_ != NULL)
         {
-            if(!pTrigger->isForPlayer()) {  // The PlayerTrigger is not exclusively for Pawns which means we cannot extract one.
-                orxout(verbose, context::docking) << "Docking:execute PlayerTrigger was not triggered by a player.." << endl;
-                return false;
-            }
-            player_ = pTrigger->getTriggeringPlayer();  //Get the object which triggered the event.
+            
+            player_ = this->pTrigger_->getTriggeringPlayer();  //Get the object which triggered the event.
         }
         else
         {
-            orxout(verbose, context::docking) << "Docking::execute Not a player trigger, can't extract pawn from it.." << endl;
+            orxout() << "ControllerDirector::preparationToTakeControl Not a player trigger, can't extract pawn from it.." << endl;
             return false;
         }
@@ -85,22 +99,23 @@
 	assert(this->entity_);
 
+    return true;
+
     }
 
-    void ScriptController::setNewController(Controller * controller) {
+    void ControllerDirector::setNewController(Controller * controller) {
 
 
-            orxout(verbose) << "New Controller is going to be set!" << endl;
+        orxout() << "New Controller is going to be set!" << endl;
 
-            this->entity_->setDestroyWhenPlayerLeft(false);
-            this->player_->pauseControl();
-            this->entity_->setController(controller);
-            this->setControllableEntity(this->entity_);
+        this->entity_->setDestroyWhenPlayerLeft(false);
+        this->player_->pauseControl();
+        this->entity_->setController(controller);
+        this->setControllableEntity(this->entity_);
+
+    }
        
     
 
-    }
-
-  
-
+}
 
 /* Detaillierte Planung
@@ -134,3 +149,2 @@
 
 
-}
Index: code/branches/ScriptableController/src/orxonox/controllers/ControllerDirector.h
===================================================================
--- code/branches/ScriptableController/src/orxonox/controllers/ControllerDirector.h	(revision 10023)
+++ code/branches/ScriptableController/src/orxonox/controllers/ControllerDirector.h	(revision 10024)
@@ -45,8 +45,12 @@
             virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
             bool party(bool bTriggered, BaseObject* trigger);
-	    void tick(float dt);
+	    virtual void XMLEventPort(Element& xmlelement, XMLPort::Mode mode);
+	
+	
+	
 	    void takeControl(Controller * controller, BaseObject * trigger);
 	    bool preparationToTakeControl(BaseObject * trigger);
 	    void setNewController(Controller * controller);
+	
 
 
@@ -55,5 +59,5 @@
 	   PlayerInfo* player_;
 
-           ControllableEntity* entity_; 
+      	   ControllableEntity* entity_; 
 
 	   PlayerTrigger * pTrigger_;